'*******************************************************************************
'
'                            SIEMENS-S65 LCD Test
'
'                             resolution 132x176
'
'*******************************************************************************
$regfile = "usb1286.dat"
$crystal = 8000000
$hwstack = 256
$swstack = 256
$framesize = 256

'-------------------------------------------------------------------------------
$lib "glcd-SIEMENS-S65.lib"                                 'library

Config Graphlcd = Color , A0 = Porta.4 , Si = Porta.0 , Sclk = Porta.1 , Cs1 = Porta.2 , Rst = Porta.3

Const Portrait = 0                                          'Portrait/Landscape Mode

'Const Cls_black = 1                                         'LCD fills black with "Cls" command

'-------------------------------------------------------------------------------
Dim N As Byte , I As Byte , K As Byte , Count As Byte
Dim Color As Byte

Const Blue = &B00000011
Const Yellow = &B11111100
Const Red = &B11100000
Const Green = &B00011100
Const Black = &B00000000
Const White = &B11111111
Const Brightgreen = &B00111110
Const Darkgreen = &B00010100
Const Darkred = &B10100000
Const Darkblue = &B00000010
Const Brightblue = &B00011111
Const Orange = &B11111000
Const Violet = &B11100011


' 16-bit color Picture Subroutine
Declare Sub Showpic16(byval X As Byte , Byval Y As Byte , Byval Width As Byte , Byval Height As Byte)

'============================== Program ========================================
'Waitms 500
Initlcd

Do
   #if Portrait > 0
'--------------------------------------------------------------- Portrate Mode
      Cls
      Setfont Color16x16
      Lcdat 20 , 10 , "SIEMENS" , Blue , White              ' ****** Text
      Lcdat 40 , 34 , "S-65" , Blue , White
      Lcdat 60 , 26 , "LS020" , Darkred , White
      Lcdat 120 , 10 , "132x176" , Red , White
      Setfont Color8x8
      Lcdat 85 , 24 , "Controller" , Darkgreen , White
      Lcdat 97 , 14 , "Sharp LR38826" , Darkgreen , White
      Wait 2


      Boxfill(0 , 0) -(131 , 175) , Black
      Setfont Color16x16
      Lcdat 5 , 20 , "Pixels" , White , Black               '****** Pixel
      Waitms 500
      For Count = 8 To 131 Step 16
         For N = 25 To 175 Step 16
            Pset Count , N , White
         Next N
      Next Count
      Waitms 500
      For Count = 16 To 131 Step 8
         For N = 33 To 175 Step 8
            Pset Count , N , White
         Next N
      Next Count
      Waitms 500
      For Count = 12 To 131 Step 4
         For N = 29 To 175 Step 4
            Pset Count , N , White
         Next N
      Next Count
      Wait 2

      Cls
      Setfont Color16x16
      Lcdat 5 , 28 , "Lines" , Black , White                '****** Line
      Line(0 , 0) -(131 , 175) , Red
      Line(0 , 175) -(131 , 0) , Darkgreen
      Line(0 , 88) -(131 , 88) , Blue
      Line(66 , 25) -(66 , 175) , Black
      Wait 2


      Cls
      Setfont Color16x16
      Lcdat 5 , 28 , "Boxes" , Black , White                '****** Box
      For N = 8 To 66 Step 8
         K = 131 - N
         I = 175 - N
         Count = 22 + N
         Box(n , Count) -(k , I) , Blue
      Next
      Wait 2


      Cls
      Setfont Color16x16
      Lcdat 80 , 12 , "FillBox" , Black , White             '****** Filled Box
      Boxfill(5 , 5) -(55 , 55) , Black
      Boxfill(76 , 5) -(126 , 55) , Blue
      Boxfill(5 , 120) -(55 , 170) , Red
      Boxfill(76 , 120) -(126 , 170) , Green
      Wait 2


      Cls
      Setfont Color16x16
      Lcdat 5 , 17 , "Circle" , Black , White               '****** Circle
      For N = 5 To 50 Step 5
        If N.0 = 1 Then Color = Blue Else Color = Red
        Circle(66 , 88) , N , Color
      Next
      Wait 2


      Cls
      Setfont Color8x8
      Lcdat 10 , 16 , "8-bit Picture" , Black , White       '****** BGC Picture
      Showpic 6 , 35 , Picture
      Wait 2


      Cls
      Setfont Color8x8
      Lcdat 10 , 12 , "16-bit Picture" , Black , White      '****** 16-bit Picture
      Restore Girl
      Call Showpic16(25 , 40 , 80 , 80)
      Wait 2



'---------------------------------------------------------------- Landscape Mode
   #else
      Cls
      Setfont Color16x16
      Lcdat 10 , 32 , "SIEMENS" , Blue , White              ' ****** Text
      Lcdat 30 , 56 , "S-65" , Blue , White
      Lcdat 50 , 48 , "LS020" , Darkred , White
      Lcdat 110 , 32 , "176x132" , Red , White
      Setfont Color8x8
      Lcdat 75 , 46 , "Controller" , Darkgreen , White
      Lcdat 87 , 36 , "Sharp LR38826" , Darkgreen , White
      Wait 2


      Boxfill(0 , 0) -(175 , 131) , Black
      Setfont Color16x16
      Lcdat 5 , 42 , "Pixels" , White , Black               '****** Pixel
      Waitms 500
      For Count = 8 To 175 Step 16
         For N = 25 To 131 Step 16
            Pset Count , N , White
         Next N
      Next Count
      Waitms 500
      For Count = 16 To 175 Step 8
         For N = 33 To 131 Step 8
            Pset Count , N , White
         Next N
      Next Count
      Waitms 500
      For Count = 12 To 175 Step 4
         For N = 29 To 131 Step 4
            Pset Count , N , White
         Next N
      Next Count
      Wait 2

      Cls
      Setfont Color16x16
      Lcdat 5 , 50 , "Lines" , Black , White                '****** Line
      Line(0 , 0) -(175 , 131) , Red
      Line(0 , 131) -(175 , 0) , Darkgreen
      Line(0 , 66) -(175 , 66) , Blue
      Line(88 , 25) -(88 , 131) , Black
      Wait 2


      Cls
      Setfont Color16x16
      Lcdat 5 , 50 , "Boxes" , Black , White                '****** Box
      For N = 8 To 50 Step 8
         K = 175 - N
         I = 131 - N
         Count = 22 + N
         Box(n , Count) -(k , I) , Blue
      Next
      Wait 2


      Cls
      Setfont Color16x16
      Lcdat 58 , 34 , "FillBox" , Black , White             '****** Filled Box
      Boxfill(5 , 5) -(55 , 55) , Black
      Boxfill(120 , 5) -(170 , 55) , Blue
      Boxfill(5 , 76) -(55 , 126) , Red
      Boxfill(120 , 76) -(170 , 126) , Green
      Wait 2


      Cls
      Setfont Color16x16
      Lcdat 5 , 39 , "Circle" , Black , White               '****** Circle
      For N = 5 To 50 Step 5
        If N.0 = 1 Then Color = Blue Else Color = Red
        Circle(88 , 76) , N , Color
      Next
      Wait 2


      Cls
      Setfont Color8x8
      Lcdat 3 , 38 , "8-bit Picture" , Black , White        '****** BGC Picture
      Showpic 28 , 11 , Picture
      Wait 2


      Cls
      Setfont Color8x8
      Lcdat 10 , 34 , "16-bit Picture" , Black , White      '****** 16-bit Picture
      Restore Girl
      Call Showpic16(48 , 30 , 80 , 80)
      Wait 2

   #endif
Loop

End

'===============================================================================
$include "color8x8.font"
$include "color16x16.font"

Picture:
$bgf "Clock.bgc"

$inc Girl , Nosize , "Girl.bin"


'-------------------------------------------------------------------------------
' 16-bit color Picture Subroutine
'-------------------------------------------------------------------------------
Sub Showpic16(byval X As Byte , Byval Y As Byte , Byval Width As Byte , Byval Height As Byte)
Local Count1 As Byte , Count2 As Byte
Local X2 As Byte , Y2 As Byte
#if Portrait = 0
   Swap X , Y
   Swap Width , Height
   X2 = 131 - X
   X = X2 + Width
   Decr X
#else
   X2 = Width + X : Decr X2
#endif
   Y2 = Height + Y : Decr Y2
   Glcdcmd 8 : Glcdcmd X : Glcdcmd 9 : Glcdcmd X2
   Glcdcmd 10 : Glcdcmd Y : Glcdcmd 11 : Glcdcmd Y2
   Glcdcmd &HE8 : Glcdcmd 12                                'Set 16-bit mode
   For Count1 = 1 To Width
      For Count2 = 1 To Height
         #if _romsize > 65536
            Read X2 : Glcddata X2
            Read X2 : Glcddata X2
         #else
            Read _temp1 : Rcall _gwrite_data
            Read _temp1 : Rcall _gwrite_data
         #endif
      Next Count2
   Next Count1
   Glcdcmd &HE8 : Glcdcmd 0                                 'Back to 8-bit mode
End Sub